/* Determines number of cities/towns/villages and their populations
 *
 * Written by Ken Witherow <phantoml@frontiernet.net>
 *
 * This code is copylefted, see the included "COPYING" file for details
 *
 */

#ifndef __KINGDOM_H__
#define __KINGDOM_H__

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

#if defined(__MSDOS__)
	#define MAXARRAY 1000
#elif defined(_Windows)
	#define MAXARRAY 1000
#else
	#define MAXARRAY 15000
#endif 

/* data */
/* number of villages, towns and cities */
unsigned int villages, towns, cities;
/* age of the kingdom */
int kingage;
/* total overall populations for v/t/c */
unsigned long int popv, popt, popc;
/* holds individual populations where 
 * [0=v 1=t 2=c][individual city]
 * need to convert domains to 0-2 to improve mem usage
 */
long int pop[3][MAXARRAY];
/* pointer to the pop array */
unsigned int countp[3];
/* kingdom's population */
unsigned long int kingpop;

/* internals */
void populate( );
void populatevillages( );
void populatetowns( );
void populatecities( );

/* exports */
extern void calctowns( unsigned long int population, int age );
extern long int sizeoftown( int typeofdomain );
extern long int getpop( int poptype );
extern int getpopcenter( int popcenter );

#endif /* __KINGDOM_H__ */